<template>
    <div class="wrapper">
        <div class="container-fuild">
            <div id="headTitle">
                <Logo />
                <h1 id="title" _msttexthash="48503" _msthash="2">{{ i18ntext.lngText('exp-report') }}</h1>
            </div>
            <Header />
            <ol id="topicPath">
                <li style="margin-left:332px">
                    <router-link to="expensesreport"><a href="#">
                            <font style="vertical-align: inherit">
                                <font style="vertical-align: inherit">{{ i18ntext.lngText('exp-report') }}</font>
                            </font>
                        </a>
                    </router-link>
                </li>
            </ol>
        </div>
        <div class="search-box">
            <div id="product">
                <div class="search-box mb-4">
                    <div class="search-box-title" id="Bars" style="padding-top: 5px;padding-bottom: 5px;padding-left:2rem;">
                        <div id="bar" style="width: 85%;">
                            <router-link to="/report"><a class="btn-radius btn btn-sm" href="#" id="bar-1">
                                    <i class="fas fa-cog"> </i>
                                    {{ i18ntext.lngText('report') }}
                                </a>
                            </router-link>
                            <router-link to="/salereport">
                                <a class="btn-radius btn btn-sm" href="#" id="bar-1">
                                    <i class="fa fa-cog" aria-hidden="true"></i>
                                    {{ i18ntext.lngText('sale-report') }}
                                </a>
                            </router-link>
                            <router-link to="/closereport">
                                <a class="btn-radius btn btn-sm" href="#" id="bar-1">
                                    <i class="fa fa-cog" aria-hidden="true"></i>
                                    {{ i18ntext.lngText('close-report') }}
                                </a>
                            </router-link>
                            <router-link to="/saleitem">
                                <a class="btn-radius btn btn-sm" href="#" id="bar-1">
                                    <i class="fa fa-cog" aria-hidden="true"></i>
                                    {{ i18ntext.lngText('item-report') }}
                                </a>
                            </router-link>
                            <router-link to="/stockinven">
                                <a class="btn-radius btn btn-sm" href="#" id="bar-1">
                                    <i class="fa fa-cog" aria-hidden="true"></i>
                                    {{ i18ntext.lngText('iven-report') }}
                                </a>
                            </router-link>
                            <router-link to="/expensesreport">
                                <a class="btn-radius btn btn-sm" href="#" id="bar-1"
                                    style="background-color: #29a5a5; border: #22adb763 1px solid;">
                                    <i class="fas fa-cog"> </i>
                                    {{ i18ntext.lngText('exp-report') }}
                                </a>
                            </router-link>
                            <router-link to="/incomereport">
                                <a class="btn-radius btn btn-sm" href="#" id="bar-1">
                                    <i class="fa fa-cog" aria-hidden="true"></i>
                                    {{ i18ntext.lngText('icm-report') }}
                                </a>
                            </router-link>
                            <router-link to="/incomepen">
                                <a class="btn-radius btn btn-sm" href="#" id="bar-1">
                                    <i class="fa fa-cog" aria-hidden="true"></i>
                                    {{ i18ntext.lngText('icm-exp') }}
                                </a>
                            </router-link>
                        </div>
                        <div id="right" style="width: 15%;">
                            <a class="btn-radius bt-pn btn btn-sm" data-bs-toggle="dropdown" aria-expanded="false"
                                style="float: right; color: #f8f5b4;margin-top: -2px;margin-right: 11px;">
                                <i class="fas fa-plus"></i>
                                {{ i18ntext.lngText('menu') }}
                            </a>
                            <ul class="dropdown-menu">
                                <li>
                                    <a class="dropdown-item btn btn-primary"
                                        data-bs-toggle="modal" data-bs-target="#staticboomId" tabindex="10028">
                                        <i class="fa fa-print" aria-hidden="true"></i>
                                        {{ i18ntext.lngText('print') }}
                                    </a>
                                </li>
                            </ul>
                        </div>
                    </div>
                    <div class="box">
                        <table width="100%" border="0" cellpadding="0" cellspacing="0" class="table table-striped br-table">
                            <thead>
                                <tr class="header-table">
                                    <th colspan="5">
                                    </th>
                                    <th style="width: 12em !important;">
                                    </th>
                                    <th class="exp">
                                        <div>
                                            <span>
                                                <input autocomplete="off" id="search" name="search" type="date" class="text"
                                                    @change="mySearch()" v-model="search.start" placeholder="Search"
                                                    style="margin-right: 0px !important; width: 86px;">
                                            </span>
                                            <span style="margin: 0px 3px;">To</span>
                                            <span>
                                                <input autocomplete="off" id="search" name="search" @change="mySearch()" v-model="search.end"
                                                    type="date" class="text" placeholder="Search"
                                                    style="margin-right: 0px !important; width: 86px;">
                                            </span>
                                        </div>
                                    </th>
                                </tr>
                                <tr class="header-table">
                                    <th style="width: 4%;">{{ i18ntext.lngText('no') }}</th>
                                    <th style="width: 12%;">{{ i18ntext.lngText('document_no') }}</th>
                                    <th style="width: 15%;">{{ i18ntext.lngText('exp_doc') }}</th>
                                    <th style="max-width: 40%;">{{ i18ntext.lngText('description') }}</th>
                                    <th style="width: 11%;">{{ i18ntext.lngText('payment_method') }}</th>
                                    <th>{{ i18ntext.lngText('total_exp') }}</th>
                                    <th style="width: 12%;">{{ i18ntext.lngText('date') }}</th>
                                </tr>
                                <tr class="header-table">
                                    <th colspan="9" style="text-align: start;cursor: pointer;" data-bs-toggle="collapse" href="#General">
                                        {{ i18ntext.lngText('gen_exp') }} <i class="fa fa-chevron-down" aria-hidden="true"></i>
                                    </th>
                                </tr>
                            </thead>
                            <tbody v-for="(item, inde) in items" :key="inde" style="border: none;" id="loop">
                                <tr id="General"  data-bs-toggle="collapse" :href="'#' + (item.el.expenses_name).replaceAll(' ','')"
                                    class="collapse tr" style="cursor: pointer;">
                                    <td>{{ inde + 1 }}</td>
                                    <td style="text-align: left;">{{ item.el.expenses_name }} <i style="color: #777;"
                                            class="fa fa-chevron-down" aria-hidden="true"></i></td>
                                    <td></td>
                                    <td>{{ item.el.description }}</td>
                                    <td>ALL</td>
                                    <td>
                                        <span style="color: blue;">
                                            {{ Number(item.total).toLocaleString() }} ៛
                                        </span>
                                        <span style="color: red; float: right;">
                                            {{Number(item.total/rate).toLocaleString()}} $
                                        </span>
                                    </td>
                                    <td style="text-align: right;">{{ formatdatetime(this.search.start) }} - {{ formatdatetime(this.search.end) }}</td>
                                </tr>
                                <tr v-for="(x, index) in item.detail" class="collapse tr" :id="(item.el.expenses_name).replaceAll(' ','')"
                                    style="background-color: #f8f5b465;">
                                    <td style="text-align: center;">{{ inde + 1}}.{{ index + 1 }}</td>
                                    <td>{{ x.document_no }}</td>
                                    <td>{{ x.document }}</td>
                                    <td>{{ x.description }}</td>
                                    <td>{{ x.Payment_method }}</td>
                                    <td>
                                        <span>
                                            {{ Number(x.totat_exspan).toLocaleString() }} ​៛
                                        </span>
                                        <span style="float: right;">
                                            {{Number(x.totat_exspan/rate).toLocaleString()}} $
                                        </span>
                                    </td>
                                    <td style="text-align: right;">{{ formatdatetime(x.exspan_date) }}</td>
                                </tr>
                            </tbody>
                            <tbody id="General" class="collapse" style="border: none;">
                               <tr>
                                    <td colspan="5">Total</td>
                                    <td>
                                        <span style="color: blue;">
                                            {{ Number(count).toLocaleString() }} ៛
                                        </span>
                                        <span style="color: red;float:right;">
                                            {{ Number(count/rate).toLocaleString() }} $
                                        </span>
                                    </td>
                                    <td></td>
                               </tr>
                            </tbody>
                            <thead>
                                <tr class="header-table">
                                    <th colspan="9" style="text-align: start;cursor: pointer;" data-bs-toggle="collapse" href="#collapseExample1">
                                        {{i18ntext.lngText('pur_exp')}} <i class="fa fa-chevron-down" aria-hidden="true"></i>
                                    </th>
                                </tr>
                            </thead>
                            <tbody v-if="purchase != null" class="collapse" id="collapseExample1">
                                <tr style="text-align: start;cursor: pointer;" data-bs-toggle="collapse" href="#purch">
                                    <td></td>
                                    <td v-if="purchase != null">{{purchase.description}}<i class="fa fa-chevron-down" aria-hidden="true" style="color: rgb(119, 119, 119);"></i></td>
                                    <td v-else></td>
                                    <td></td>
                                    <td></td>
                                    <td v-if="purchase != null"> {{ purchase.method }}</td>
                                    <td v-else></td>
                                    <td v-if="purchase != null">
                                      <span style="color:blue"> {{ Number(purchase.total_riel).toLocaleString() }} ៛</span>
                                      <span style="color:red; float:right">{{ Number(purchase.total_usd).toLocaleString() }} $</span>
                                    </td>
                                    <td v-else></td>
                                    <td style="text-align: right;">{{ formatdatetime(search.start) }} - {{ formatdatetime(search.end) }}</td>
                                </tr>
                                <tr  style="background-color: #f8f5b465;" v-if="purchase != null" v-for="(item, index) in purchase.items" class="collapse" id="purch">
                                    <td>{{ index + 1 }}</td>
                                    <td>{{ item.document_no }}</td>
                                    <td>{{ item.document }}</td>
                                    <td>{{ item.decription }}</td>
                                    <td></td>
                                    <td>{{ Number(item.total_amount).toLocaleString() }} ៛</td>
                                    <td style="text-align: right;">{{ formatdatetime(search.start) }} - {{ formatdatetime(search.end) }}</td>
                                </tr>

                                <tr>
                                    <td colspan="5">Subtotal for Riel</td>
                                    <td v-if="purchase != null">
                                        <span style="color:blue">
                                            {{ Number(purchase.total_riel).toLocaleString() }} ៛
                                        </span>
                                        <span style="color:red; float:right">
                                            {{ Number(purchase.total_riel / rate).toLocaleString() }} $
                                        </span>

                                    </td>
                                    <td v-else>
                                        <span style="color:blue">
                                            0 ៛
                                        </span>
                                        <span style="color:red; float:right">
                                            0 $
                                        </span>



                                    </td>
                                    <td style="text-align: right;">
                                    </td>
                                </tr>
                            </tbody>
                            <thead>
                                <tr class="header-table">
                                    <th colspan="9" style="text-align: start;cursor: pointer;" data-bs-toggle="collapse" href="#stock">
                                        {{ i18ntext.lngText('st_sk') }} <i class="fa fa-chevron-down" aria-hidden="true"></i>
                                    </th>
                                </tr>
                            </thead>
                            <tbody v-for="(ml,dex) in data" :key="dex" style="border: none;" id="loop">
                                <tr id="stock"  data-bs-toggle="collapse" :href="'#' + ml.paymentmethod_code+'1'"
                                class="collapse tr" style="cursor: pointer;">
                                    <td>{{dex+1}}</td>
                                    <td></td>
                                    <td>Stock Start pay by <i class="fa fa-chevron-down" aria-hidden="true" style="color: rgb(119, 119, 119);"></i></td>
                                    <td></td>
                                    <td>{{ml.paymentmethod_code}} </td>
                                    <td>
                                        <span style="color: blue;">
                                            {{Number(ml.sum).toLocaleString()}} ៛
                                        </span>
                                        <span style="float: right;color: red;">
                                            {{Number(ml.sum / rate).toLocaleString()}} $
                                        </span>
                                    </td>
                                    <td style="text-align: right;">{{formatdatetime(search.start)}} - {{formatdatetime(search.end)}}</td>
                                </tr>
                                <tr v-for="(x, index) in ml.items" :eky="index" class="collapse tr" :id="ml.paymentmethod_code+'1'" style="background-color: #f8f5b465;">
                                    <td style="text-align: center;">{{dex+1}}.{{index+1}}</td>
                                    <td>{{x.document_no}}</td>
                                    <td>{{x.document_type}}</td>
                                    <td>{{x.description}}</td>
                                    <td>{{x.paymentmethod_code}}</td>
                                    <td>
                                        <span>{{Number(x.total_amount).toLocaleString()}} ៛ </span>
                                        <span style="float: right;">
                                            {{Number(x.total_amount / rate).toLocaleString()}} $
                                        </span>
                                    </td>
                                    <td style="text-align: right;">{{formatdatetime(x.created_at)}}</td>
                                </tr>
                            </tbody>
                            <tbody id="stock" class="collapse" style="border: none;">
                                <tr>
                                    <td colspan="5">Total</td>
                                    <td>
                                        <span style="color: blue;">
                                            {{ Number(total).toLocaleString() }} ៛
                                        </span>
                                        <span style="color: red;float:right;">
                                            {{ Number(total/rate).toLocaleString() }} $
                                        </span>
                                    </td>
                                    <td></td>
                                </tr>
                            </tbody>
                            <tbody>
                                <tr class="header-table" id="hv">
                                    <td colspan="6" style="text-align: start;">{{i18ntext.lngText('total_rel')}}</td>
                                    <td style="text-align: right;">
                                        {{ Number(count+total+total_purchase).toLocaleString() }} ៛
                                    </td>
                                </tr>
                                <tr class="header-table" id="hv">
                                    <td colspan="6" style="text-align: start;">{{i18ntext.lngText('total_us')}}</td>
                                    <td style="text-align: right;">
                                        {{ Number((count+total + total_purchase) / rate).toLocaleString() }} $
                                    </td>
                                </tr>
                            </tbody>
                        </table>
                    </div>
                </div>
            </div>
        </div>
    </div>
    <div id="myModal" class="lskymodal">
        <div class="lskymodal-content">
            <p>
                <i class="fa fa-check" aria-hidden="true"></i>
                {{ massege }}
            </p>
        </div>
    </div>
    <div class="modal fade ui-modal" id="staticboomId" data-bs-backdrop="static" data-bs-keyboard="false" tabindex="-1"
        aria-labelledby="staticboomId" aria-hidden="true">
        <div class="modal-dialog" style="max-width: 85% !important;">
            <div class="modal-content ui-dialog">
                <div class="ui-widget-header">
                    <h5 class="modal-title in-header" id="staticBackdropLabel"><i class="fa fa-print"
                            aria-hidden="true"></i>
                            {{i18ntext.lngText('print')}}</h5>
                    <span class="ui-icon ui-icon-closethick" data-bs-dismiss="modal" aria-label="Close"></span>
                </div>
                <div class="ui-dialog-content" >
                    <div class="card">
                        <div class="card-body print-size">
                            <div class="mt-3 " id="purchaseorder" style="height:auto !important">

                                <div style="padding:4rem; background-color: #fff;">
                                    <div class="col-md-12">
                                        <div class="text-center">
                                            <h3 class="title-purchase">{{i18ntext.lngText('exp-report')}}</h3>
                                        </div>
                                    </div>
                                    <div class="col-container">
                                        <div class="col1" style="width: 55%;">
                                            <p class=" p-bg font-size p-pad">{{i18ntext.lngText('com-name')}}</p>
                                            <p class="p-mg info-pad"><span id="bold">{{i18ntext.lngText('name')}} :</span> <span id="fon">{{
                                                company.company_name }}</span></p>
                                            <p class="p-mg  info-pad"><span id="bold">{{i18ntext.lngText('phone')}} :</span> <span
                                                    id="fon">{{ company.company_Phone }}</span></p>
                                            <p class="p-mg info-pad"><span id="bold">{{i18ntext.lngText('email')}} :</span> <span
                                                    id="fon">{{ company.company_Email }}</span></p>
                                            <p class="p-mg info-pad"><span id="bold">{{i18ntext.lngText('address')}} :</span> <span id="fon">{{
                                                company.company_Address }}</span></p>
                                        </div>
                                        <div class="col2">
                                            <p class="text-center p-bg font-size p-pad">{{i18ntext.lngText('date')}}</p>
                                            <p class="text-center p-mg" id="fon">{{ dateformart }}</p>
                                            <p class="text-center p-bg font-size p-pad">{{i18ntext.lngText('onhand-total')}}.</p>
                                            <p class="text-center p-mg" id="fon">{{ count }}</p>
                                        </div>
                                    </div>
                                    <div class=" my-2  justify-content-center">
                                        <table id="pr-tb">
                                            <thead>
                                                <tr class="p-bg">
                                                    <th style="width: 5%;padding-left: 5px !important;">{{i18ntext.lngText('no')}}</th>
                                                    <th style="padding-left: 5px !important;">{{i18ntext.lngText('be-doc')}}</th>
                                                    <th style="padding-left: 5px !important;">{{i18ntext.lngText('exp_doc')}}</th>
                                                    <th style="padding-left: 5px !important;">{{i18ntext.lngText('description')}}</th>
                                                    <th style="padding-left: 5px !important;">{{i18ntext.lngText('payment_method')}}</th>
                                                    <th style="padding-left: 5px !important;">{{i18ntext.lngText('total_expense')}}</th>
                                                </tr>
                                                <tr class="p-bg">
                                                    <th colspan="6" style="text-align: start;padding-left: 5px !important;">
                                                        {{i18ntext.lngText('exp_date')}} : {{ formatdatetime(search.start) }} - {{formatdatetime(search.end) }}</th>
                                                </tr>
                                            </thead>
                                            <tbody v-if="items != null" v-for="(item, inde) in items" :key="inde" style="border: none;" id="loop">
                                                <tr id="General" class="price-bold">
                                                    <td>{{ inde + 1 }}</td>
                                                    <td style="text-align: left;">{{ item.el.expenses_name }}</td>
                                                    <td></td>
                                                    <td>{{ item.el.description }}</td>
                                                    <td>ALL</td>
                                                    <td>
                                                        <span>
                                                            {{ Number(item.total).toLocaleString() }} ៛
                                                        </span>
                                                        <span style="float: right;">
                                                            {{Number(item.total/rate).toLocaleString()}} $
                                                        </span>
                                                    </td>
                                                </tr>
                                                <tr v-for="(x, index) in item.detail" >
                                                    <td style="text-align: center;">{{ inde + 1}}.{{ index + 1 }}</td>
                                                    <td>{{ x.document_no }}</td>
                                                    <td>{{ x.document }}</td>
                                                    <td>{{ x.description }}</td>
                                                    <td>{{ x.Payment_method }}</td>
                                                    <td>
                                                        <span>
                                                            {{ Number(x.totat_exspan).toLocaleString() }} ​៛
                                                        </span>
                                                        <span style="float: right;">
                                                            {{Number(x.totat_exspan/rate).toLocaleString()}} $
                                                        </span>
                                                    </td>
                                                </tr>

                                            </tbody>
                                           <tr>
                                            <td></td>
                                            <td>Total</td>
                                            <td></td>
                                            <td></td>
                                            <td></td>
                                            <td class="price-bold">
                                                <span >
                                                    {{ Number(count).toLocaleString() }} ៛
                                                </span>
                                                <span style="float:right;">
                                                    {{ Number(count/rate).toLocaleString() }} $
                                                </span>
                                            </td>
                                           </tr>

                                            <thead>
                                                <tr class="p-bg">
                                                    <th colspan="6" style="text-align: start;padding-left: 5px !important;">
                                                        {{i18ntext.lngText('pur_date')}} : {{ formatdatetime(search.start) }} - {{formatdatetime(search.end) }}</th>
                                                </tr>
                                            </thead>
                                            <tbody >
                                                <tr class="price-bold">
                                                    <td></td>
                                                    <td v-if="purchase != null">{{purchase.description}}</td>
                                                    <td v-else></td>
                                                    <td></td>
                                                    <td></td>
                                                    <td v-if="purchase != null"> {{ purchase.method }}</td>
                                                    <td v-else></td>
                                                    <td v-if="purchase != null">
                                                    <span > {{ Number(purchase.total_riel).toLocaleString() }} ៛</span>
                                                    <span style="float:right">{{ Number(purchase.total_usd).toLocaleString() }} $</span>
                                                    </td>
                                                    <td v-else></td>
                                                </tr>
                                                <tr v-if="purchase != null" v-for="(item, index) in purchase.items">
                                                    <td>{{ index + 1 }}</td>
                                                    <td>{{ item.document_no }}</td>
                                                    <td>{{ item.document }}</td>
                                                    <td>{{ item.decription }}</td>
                                                    <td></td>
                                                    <td>{{ Number(item.total_amount).toLocaleString() }} ៛</td>
                                                </tr>
                                                <tr>
                                                    <td></td>
                                                    <td>Total</td>
                                                    <td></td>
                                                    <td></td>
                                                    <td></td>
                                                    <td v-if="purchase != null" class="price-bold">
                                                        <span >
                                                            {{ Number(purchase.total_riel).toLocaleString() }} ៛
                                                        </span>
                                                        <span style="float:right;">
                                                            {{ Number(purchase.total_riel/rate).toLocaleString() }} $
                                                        </span>
                                                    </td>
                                                    <td v-else class="price-bold">
                                                        <span >
                                                            0 ៛
                                                        </span>
                                                        <span style="float:right;">
                                                            0 $
                                                        </span>
                                                    </td>
                                                </tr>
                                            </tbody>
                                            <thead>
                                                <tr class="p-bg">
                                                    <th colspan="6" style="text-align: start;padding-left: 5px !important;">
                                                        {{i18ntext.lngText('stock_date')}} : {{formatdatetime(search.start) }} - {{ formatdatetime(search.end) }}</th>
                                                </tr>
                                            </thead>
                                            <tbody v-for="(ml,dex) in data" :key="dex" style="border: none;" id="loop">
                                                <tr id="stock"  class="price-bold">
                                                    <td>{{dex+1}}</td>
                                                    <td></td>
                                                    <td>Stock Start pay by</td>
                                                    <td></td>
                                                    <td>{{ml.paymentmethod_code}}</td>
                                                    <td>
                                                        <span>
                                                            {{Number(ml.sum).toLocaleString()}} ៛
                                                        </span>
                                                        <span style="float: right;">
                                                            {{Number(ml.sum / rate).toLocaleString()}} $
                                                        </span>
                                                    </td>
                                                </tr>
                                                <tr v-for="(x, index) in ml.items" :eky="index">
                                                    <td style="text-align: center;">{{dex+1}}.{{index+1}}</td>
                                                    <td>{{x.document_no}}</td>
                                                    <td>{{x.document_type}}</td>
                                                    <td>{{x.description}}</td>
                                                    <td>{{x.paymentmethod_code}}</td>
                                                    <td>
                                                        <span>{{Number(x.total_amount).toLocaleString()}} ៛ </span>
                                                        <span style="float: right;">
                                                            {{Number(x.total_amount / rate).toLocaleString()}} $
                                                        </span>
                                                    </td>
                                                </tr>
                                            </tbody>

                                            <tbody>
                                                <tr>
                                                    <td></td>
                                                    <td>Total</td>
                                                    <td></td>
                                                    <td></td>
                                                    <td></td>
                                                    <td class="price-bold">
                                                        <span>{{ Number(total).toLocaleString() }} ៛</span>
                                                        <span style="float:right">{{ Number(total / rate).toLocaleString() }} $</span>
                                                    </td>
                                                </tr>
                                            </tbody>
                                            <thead>
                                                <tr class="p-bg">
                                                    <td colspan="5" style="text-align: start;">{{i18ntext.lngText('total_rel')}}</td>
                                                    <td class="price-bold">
                                                        <div class="d-flex justify-content-end">
                                                            {{ Number(count+total+total_purchase).toLocaleString() }} ៛
                                                        </div>
                                                    </td>
                                                </tr>
                                            </thead>
                                            <thead>
                                                <tr class="p-bg">
                                                    <td colspan="5" style="text-align: start;">{{i18ntext.lngText('total_us')}}</td>
                                                    <td class="price-bold">
                                                        <div class="d-flex justify-content-end">
                                                            {{ Number((count+total + total_purchase) / rate).toLocaleString() }} $
                                                        </div>
                                                    </td>
                                                </tr>
                                            </thead>
                                        </table>
                                        <span class="price-bold float-right" style="margin-top: 2rem;">{{i18ntext.lngText('report_by')}} : {{employee.firstname}} {{employee.lstname}}</span>
                                    </div>
                                    <hr>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
                <div class="modal-footer">
                    <a v-print="'#purchaseorder'" class="btn-purchase btn-light text-capitalize border-0"
                        data-mdb-ripple-color="dark"><i class="fas fa-print text-primary"></i> {{i18ntext.lngText('print')}}</a>
                </div>
            </div>
        </div>
    </div>
    <Footer />
    <UserInfo />
</template>

<script>
import axios from "axios";
import { isProxy, toRaw } from 'vue';
import { useCurrentTime } from "../../componentJS/date";
import pagination from "laravel-vue-pagination";
import moment from "moment";
import Logo from "../logo.vue"
import Header from "../Header.vue";
import Footer from "../footer.vue";
import print from 'vue3-print-nb';
import Auth from "../../auth/Auth";
import UserInfo from "../UserInfo.vue"
import i18n from "../../i18n/i18n";
export default {
    components: { pagination, Header, Footer, Logo,UserInfo },
    directives: { print },
    setup() {
        const { currentTime } = useCurrentTime();
        return { currentTime };
    },

    data() {
        return {
            i18ntext: i18n,
            date: null,
            company: [],
            items: [],
            detailsOne: [],
            detailsTow: [],
            detailsTree: [],
            details: [],
            employee:[],
            sel: [],
            data:[],
            Pay: "",
            all: "",
            count: 0,
            massege: "",
            sum: 0,
            form: {
                id: "",
                document_no: "",
                document: "",
                description: "",
                Payment_method: "",
                totat_exspan: "",
                statue: "",
                exspan_date: "",
                created_by: "",
                updated_by: '',
                user_name: "",
            },
            search: {
                name: "",
                Pay: "",
                exspan: "",
                start: "",
                end: "",
            },
            document_no: "ss",
            document: "",
            purchase: [],
            total_purchase : 0,
        };
    },
    mounted() {
        if (Auth.check()) {
        if(!Auth.checkPermission('EXPENSESREPORT_ALL')){
            this.$router.push('/dashboard');
        }
    }
        this.messagebox()
        this.selectpayment()
        this.search.end = moment(new Date()).format('YYYY-MM-DD');
        const mydate = new Date();
        this.search.start = moment(mydate.setMonth(mydate.getMonth() - 1)).format('YYYY-MM-DD');
        this.viewex()
        this.getExpense()
        this.getcompany()
        this.getstock()
        this.employeeName()

    },
    methods: {
        async getExpense(){
             await axios.post('api/v1/report/getexpense?created_by='+Auth.user.id+'&startDate='+this.search.start+'&endDate='+this.search.end)
                        .then(res => {
                            this.purchase = res.data.purchase[0]
                            if(this.purchase != null){
                                this.total_purchase = this.purchase.total_riel
                            }
                            else{
                                this.total_purchase = 0
                            }

                        })
        },
        employeeName(){
            axios.post('/api/v1/employee_name',Auth.user)
            .then(res =>{
                this.employee = res.data
                console.log(this.employee.firstname);
            })
        },
        async getcompany() {
            await axios.get("/api/v1/getSetup/")
                .then((response) => {
                    this.company = response.data;
                    this.dateformart = moment(new Date()).format('DD-MM-YYYY');
                });
        },
        async viewex() {
            axios.get("/api/v1/expensDetial/" + Auth.user.id + "?start=" + this.search.start + "&end=" + this.search.end)
                .then(res => {
                    this.items = res.data.data
                    this.rate = res.data.rate
                    this.count = 0
                    this.items.forEach(e => {
                        this.count += parseFloat(e.total)
                    });
                })
        },
        async getstock(){


            await axios.get("api/v1/beginningstock/stockStart/"+Auth.user.id+"?start="+this.search.start+"&end=" + this.search.end)
            .then(({data}) =>{
                this.data = data.data
                this.total = data.total
                this.rate = data.rate
            })
        },
        selectpayment() {
            axios.get("api/v1/paymentvoucher/getPaymenmethod/")
                .then(res => {
                    this.sel = res.data
                })
        },
        getproduct(label, txt) {
            if (txt == 'payment') {
                if (label == 'ALL') {
                    this.Pay = label
                } else {
                    this.Pay = label.paymentmethod
                }
                this.search = {
                    'Pay': this.Pay,
                    'start': this.search.start,
                    'end': this.search.end,
                }
                this.mySearch()
            }
        },
     async   mySearch() {
                this.viewex()
                this.getExpense()
                this.getstock()
        },
        formatdatetime(dateform) {
            try {
                return moment(dateform).format('DD-MM-YYYY');
            } catch (error) {
                return dateform;
            }
        },
     async messagebox() {
            var modal = document.getElementById("myModal");
            modal.style.display = "block";
            setTimeout(() => (modal.style.display = "none"), 2000);
        },
    },
};
</script>
